Index: /trunk/sources/HeuristicLab.Problems.ArtificialAnt/3.3/ArtificialAntProblem.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.ArtificialAnt/3.3/ArtificialAntProblem.cs	(revision 4117)
+++ /trunk/sources/HeuristicLab.Problems.ArtificialAnt/3.3/ArtificialAntProblem.cs	(revision 4118)
@@ -278,8 +278,13 @@
     #region Helpers
     [StorableHook(HookType.AfterDeserialization)]
+    private void AfterDeserializationHook() {
+      // BackwardsCompatibility3.3
+      #region Backwards compatible code (remove with 3.4)
+      if (operators == null) InitializeOperators();
+      #endregion
+      AttachEventHandlers();
+    }
+
     private void AttachEventHandlers() {
-      // Start BackwardsCompatibility3.3 (remove with 3.4)
-      if (operators == null) InitializeOperators();
-      // End BackwardsCompatibility3.3
       SolutionCreatorParameter.ValueChanged += new EventHandler(SolutionCreatorParameter_ValueChanged);
       SolutionCreator.SymbolicExpressionTreeParameter.ActualNameChanged += new EventHandler(SolutionCreator_SymbolicExpressionTreeParameter_ActualNameChanged);
Index: /trunk/sources/HeuristicLab.Problems.DataAnalysis.FeatureSelection/3.3/FeatureSelectionProblem.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.DataAnalysis.FeatureSelection/3.3/FeatureSelectionProblem.cs	(revision 4117)
+++ /trunk/sources/HeuristicLab.Problems.DataAnalysis.FeatureSelection/3.3/FeatureSelectionProblem.cs	(revision 4118)
@@ -90,5 +90,5 @@
 
     [StorableConstructor]
-    private FeatureSelectionProblem(bool deserializing) : base() { }
+    protected FeatureSelectionProblem(bool deserializing) : base(deserializing) { }
     public FeatureSelectionProblem()
       : base() {
@@ -106,9 +106,14 @@
 
       InitializeOperators();
-      AttachEventHandlers();
+      RegisterParameterEvents();
+      RegisterParameterValueEvents();
     }
 
     [StorableHook(HookType.AfterDeserialization)]
     private void AfterDeserializationHook() {
+      // BackwardsCompatibility3.3
+      #region Backwards compatible code (remove with 3.4)
+      if (operators == null) InitializeOperators();
+      #endregion
       RegisterParameterEvents();
       RegisterParameterValueEvents();
@@ -118,5 +123,6 @@
       FeatureSelectionProblem clone = (FeatureSelectionProblem)base.Clone(cloner);
       clone.operators = operators.Select(x => (IOperator)cloner.Clone(x)).ToList();
-      clone.AttachEventHandlers();
+      clone.RegisterParameterEvents();
+      clone.RegisterParameterValueEvents();
       return clone;
     }
@@ -168,12 +174,4 @@
 
     #region Helpers
-    private void AttachEventHandlers() {
-      // Start BackwardsCompatibility3.3 (remove with 3.4)
-      if (operators == null) InitializeOperators();
-      // End BackwardsCompatibility3.3
-      RegisterParameterEvents();
-      RegisterParameterValueEvents();
-    }
-
     private void InitializeOperators() {
       operators = new List<IOperator>();
Index: /trunk/sources/HeuristicLab.Problems.DataAnalysis.MultiVariate.Regression/3.3/Symbolic/MultiObjectiveSymbolicVectorRegressionProblem.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.DataAnalysis.MultiVariate.Regression/3.3/Symbolic/MultiObjectiveSymbolicVectorRegressionProblem.cs	(revision 4117)
+++ /trunk/sources/HeuristicLab.Problems.DataAnalysis.MultiVariate.Regression/3.3/Symbolic/MultiObjectiveSymbolicVectorRegressionProblem.cs	(revision 4118)
@@ -66,4 +66,6 @@
     #endregion
 
+    [StorableConstructor]
+    protected MultiObjectiveSymbolicVectorRegressionProblem(bool deserializing) : base(deserializing) { }
     public MultiObjectiveSymbolicVectorRegressionProblem()
       : base() {
@@ -75,8 +77,5 @@
       Initialize();
     }
-
-    [StorableConstructor]
-    private MultiObjectiveSymbolicVectorRegressionProblem(bool deserializing) : base() { }
-
+    
     [StorableHook(HookType.AfterDeserialization)]
     private void AfterDeserializationHook() {
Index: /trunk/sources/HeuristicLab.Problems.DataAnalysis.MultiVariate.Regression/3.3/Symbolic/SymbolicVectorRegressionProblem.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.DataAnalysis.MultiVariate.Regression/3.3/Symbolic/SymbolicVectorRegressionProblem.cs	(revision 4117)
+++ /trunk/sources/HeuristicLab.Problems.DataAnalysis.MultiVariate.Regression/3.3/Symbolic/SymbolicVectorRegressionProblem.cs	(revision 4118)
@@ -119,5 +119,4 @@
     }
 
-    private List<IOperator> operators;
     public override IEnumerable<IOperator> Operators {
       get { return operators; }
@@ -154,5 +153,9 @@
     [Storable]
     private SymbolicVectorRegressionGrammar grammar;
-
+    [Storable]
+    private List<IOperator> operators;
+
+    [StorableConstructor]
+    protected SymbolicVectorRegressionProblem(bool deserializing) : base(deserializing) { }
     public SymbolicVectorRegressionProblem()
       : base() {
@@ -175,18 +178,24 @@
       UpdateGrammar();
       UpdateEstimationLimits();
-      Initialize();
-    }
-
-    [StorableConstructor]
-    private SymbolicVectorRegressionProblem(bool deserializing) : base() { }
+      InitializeOperators();
+      RegisterParameterEvents();
+      RegisterParameterValueEvents();
+    }
 
     [StorableHook(HookType.AfterDeserialization)]
     private void AfterDeserializationHook() {
-      Initialize();
+      // BackwardsCompatibility3.3
+      #region Backwards compatible code (remove with 3.4)
+      if (operators == null) InitializeOperators();
+      #endregion
+      RegisterParameterEvents();
+      RegisterParameterValueEvents();
     }
 
     public override IDeepCloneable Clone(Cloner cloner) {
       SymbolicVectorRegressionProblem clone = (SymbolicVectorRegressionProblem)base.Clone(cloner);
-      clone.Initialize();
+      clone.operators = operators.Select(x => (IOperator)cloner.Clone(x)).ToList();
+      clone.RegisterParameterEvents();
+      clone.RegisterParameterValueEvents();
       return clone;
     }
@@ -254,10 +263,4 @@
     protected void AddOperator(IOperator op) {
       operators.Add(op);
-    }
-
-    private void Initialize() {
-      InitializeOperators();
-      RegisterParameterEvents();
-      RegisterParameterValueEvents();
     }
 
Index: /trunk/sources/HeuristicLab.Problems.DataAnalysis.MultiVariate.TimeSeriesPrognosis/3.3/Symbolic/SingleObjectiveSymbolicTimeSeriesPrognosisProblem.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.DataAnalysis.MultiVariate.TimeSeriesPrognosis/3.3/Symbolic/SingleObjectiveSymbolicTimeSeriesPrognosisProblem.cs	(revision 4117)
+++ /trunk/sources/HeuristicLab.Problems.DataAnalysis.MultiVariate.TimeSeriesPrognosis/3.3/Symbolic/SingleObjectiveSymbolicTimeSeriesPrognosisProblem.cs	(revision 4118)
@@ -85,5 +85,6 @@
     #endregion
 
-
+    [StorableConstructor]
+    protected SingleObjectiveSymbolicTimeSeriesPrognosisProblem(bool deserializing) : base(deserializing) { }
     public SingleObjectiveSymbolicTimeSeriesPrognosisProblem()
       : base() {
@@ -96,18 +97,16 @@
       ParameterizeEvaluator();
 
-      Initialize();
+      InitializeOperators();
+      AttachEventHandlers();
     }
-
-    [StorableConstructor]
-    protected SingleObjectiveSymbolicTimeSeriesPrognosisProblem(bool deserializing) : base(deserializing) { }
 
     [StorableHook(HookType.AfterDeserialization)]
     private void AfterDeserializationHook() {
-      Initialize();
+      AttachEventHandlers();
     }
 
     public override IDeepCloneable Clone(Cloner cloner) {
       SingleObjectiveSymbolicTimeSeriesPrognosisProblem clone = (SingleObjectiveSymbolicTimeSeriesPrognosisProblem)base.Clone(cloner);
-      clone.Initialize();
+      clone.AttachEventHandlers();
       return clone;
     }
@@ -135,6 +134,5 @@
 
     #region Helpers
-    private void Initialize() {
-      InitializeOperators();
+    private void AttachEventHandlers() {
     }
 
Index: /trunk/sources/HeuristicLab.Problems.DataAnalysis.MultiVariate.TimeSeriesPrognosis/3.3/Symbolic/SymbolicTimeSeriesPrognosisProblem.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.DataAnalysis.MultiVariate.TimeSeriesPrognosis/3.3/Symbolic/SymbolicTimeSeriesPrognosisProblem.cs	(revision 4117)
+++ /trunk/sources/HeuristicLab.Problems.DataAnalysis.MultiVariate.TimeSeriesPrognosis/3.3/Symbolic/SymbolicTimeSeriesPrognosisProblem.cs	(revision 4118)
@@ -122,5 +122,4 @@
       set { FunctionTreeGrammarParameter.Value = value; }
     }
-    private List<IOperator> operators;
     public override IEnumerable<IOperator> Operators {
       get { return operators; }
@@ -157,5 +156,9 @@
     [Storable]
     private SymbolicTimeSeriesPrognosisGrammar grammar;
-
+    [Storable]
+    private List<IOperator> operators;
+
+    [StorableConstructor]
+    protected SymbolicTimeSeriesPrognosisProblem(bool deserializing) : base(deserializing) { }
     public SymbolicTimeSeriesPrognosisProblem()
       : base() {
@@ -179,19 +182,25 @@
 
       UpdateGrammar();
-      Initialize();
-    }
-
-    [StorableConstructor]
-    protected SymbolicTimeSeriesPrognosisProblem(bool deserializing) : base(deserializing) { }
+      InitializeOperators();
+      RegisterParameterEvents();
+      RegisterParameterValueEvents();
+    }
 
     [StorableHook(HookType.AfterDeserialization)]
     private void AfterDeserializationHook() {
-      Initialize();
+      // BackwardsCompatibility3.3
+      #region Backwards compatible code (remove with 3.4)
+      if (operators == null) InitializeOperators();
+      #endregion
+      RegisterParameterEvents();
+      RegisterParameterValueEvents();
     }
 
     public override IDeepCloneable Clone(Cloner cloner) {
       SymbolicTimeSeriesPrognosisProblem clone = (SymbolicTimeSeriesPrognosisProblem)base.Clone(cloner);
+      clone.operators = operators.Select(x => (IOperator)cloner.Clone(x)).ToList();
       clone.grammar = (SymbolicTimeSeriesPrognosisGrammar)cloner.Clone(grammar);
-      clone.Initialize();
+      clone.RegisterParameterEvents();
+      clone.RegisterParameterValueEvents();
       return clone;
     }
@@ -253,10 +262,4 @@
     protected void AddOperator(IOperator op) {
       operators.Add(op);
-    }
-
-    private void Initialize() {
-      InitializeOperators();
-      RegisterParameterEvents();
-      RegisterParameterValueEvents();
     }
 
Index: /trunk/sources/HeuristicLab.Problems.DataAnalysis.Regression/3.3/Symbolic/SymbolicRegressionProblem.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.DataAnalysis.Regression/3.3/Symbolic/SymbolicRegressionProblem.cs	(revision 4117)
+++ /trunk/sources/HeuristicLab.Problems.DataAnalysis.Regression/3.3/Symbolic/SymbolicRegressionProblem.cs	(revision 4118)
@@ -183,5 +183,5 @@
 
     [StorableConstructor]
-    private SymbolicRegressionProblem(bool deserializing) : base() { }
+    protected SymbolicRegressionProblem(bool deserializing) : base(deserializing) { }
     public SymbolicRegressionProblem()
       : base() {
@@ -213,5 +213,6 @@
       UpdateEstimationLimits();
       InitializeOperators();
-      AttachEventHandlers();
+      RegisterParameterEvents();
+      RegisterParameterValueEvents();
     }
 
@@ -219,5 +220,6 @@
       SymbolicRegressionProblem clone = (SymbolicRegressionProblem)base.Clone(cloner);
       clone.operators = operators.Select(x => (IOperator)cloner.Clone(x)).ToList();
-      clone.AttachEventHandlers();
+      clone.RegisterParameterEvents();
+      clone.RegisterParameterValueEvents();
       return clone;
     }
@@ -303,8 +305,9 @@
     #region Helpers
     [StorableHook(HookType.AfterDeserialization)]
-    private void AttachEventHandlers() {
-      // Start BackwardsCompatibility3.3 (remove with 3.4)
+    private void AfterDeserializationHook() {
+      // BackwardsCompatibility3.3
+      #region Backwards compatible code (remove with 3.4)
       if (operators == null) InitializeOperators();
-      // End BackwardsCompatibility3.3
+      #endregion
       RegisterParameterEvents();
       RegisterParameterValueEvents();
Index: /trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/DataAnalysisProblem.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/DataAnalysisProblem.cs	(revision 4117)
+++ /trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/DataAnalysisProblem.cs	(revision 4118)
@@ -50,4 +50,6 @@
     #endregion
 
+    [StorableConstructor]
+    protected DataAnalysisProblem(bool deserializing) : base(deserializing) { }
     public DataAnalysisProblem()
       : base() {
@@ -56,7 +58,4 @@
       RegisterParameterValueEvents();
     }
-
-    [StorableConstructor]
-    private DataAnalysisProblem(bool deserializing) : base() { }
 
     [StorableHook(HookType.AfterDeserialization)]
Index: /trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/SupportVectorMachine/ParameterAdjustmentProblem/SupportVectorMachineParameterAdjustmentProblem.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/SupportVectorMachine/ParameterAdjustmentProblem/SupportVectorMachineParameterAdjustmentProblem.cs	(revision 4117)
+++ /trunk/sources/HeuristicLab.Problems.DataAnalysis/3.3/SupportVectorMachine/ParameterAdjustmentProblem/SupportVectorMachineParameterAdjustmentProblem.cs	(revision 4118)
@@ -129,5 +129,5 @@
 
     [StorableConstructor]
-    private SupportVectorMachineParameterAdjustmentProblem(bool deserializing) : base() { }
+    private SupportVectorMachineParameterAdjustmentProblem(bool deserializing) : base(deserializing) { }
     public SupportVectorMachineParameterAdjustmentProblem()
       : base() {
@@ -216,8 +216,13 @@
     #region Helpers
     [StorableHook(HookType.AfterDeserialization)]
+    private void AfterDeserializationHook() {
+      // BackwardsCompatibility3.3
+      #region Backwards compatible code (remove with 3.4)
+      if (operators == null) InitializeOperators();
+      #endregion
+      AttachEventHandlers();
+    }
+
     private void AttachEventHandlers() {
-      // Start BackwardsCompatibility3.3 (remove with 3.4)
-      if (operators == null) InitializeOperators();
-      // End BackwardsCompatibility3.3
       SolutionCreatorParameter.ValueChanged += new EventHandler(SolutionCreatorParameter_ValueChanged);
       SolutionCreator.RealVectorParameter.ActualNameChanged += new EventHandler(SolutionCreator_RealVectorParameter_ActualNameChanged);
Index: /trunk/sources/HeuristicLab.Problems.ExternalEvaluation/3.3/ExternalEvaluationProblem.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.ExternalEvaluation/3.3/ExternalEvaluationProblem.cs	(revision 4117)
+++ /trunk/sources/HeuristicLab.Problems.ExternalEvaluation/3.3/ExternalEvaluationProblem.cs	(revision 4118)
@@ -193,4 +193,8 @@
     #region Helpers
     [StorableHook(HookType.AfterDeserialization)]
+    private void AfterDeserializationHook() {
+      AttachEventHandlers();
+    }
+
     private void AttachEventHandlers() {
       SolutionCreatorParameter.ValueChanged += new EventHandler(SolutionCreatorParameter_ValueChanged);
Index: /trunk/sources/HeuristicLab.Problems.Knapsack/3.3/KnapsackProblem.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.Knapsack/3.3/KnapsackProblem.cs	(revision 4117)
+++ /trunk/sources/HeuristicLab.Problems.Knapsack/3.3/KnapsackProblem.cs	(revision 4118)
@@ -138,5 +138,5 @@
 
     [StorableConstructor]
-    private KnapsackProblem(bool deserializing) : base() { }
+    private KnapsackProblem(bool deserializing) : base(deserializing) { }
     public KnapsackProblem()
       : base() {
@@ -255,8 +255,13 @@
     #region Helpers
     [StorableHook(HookType.AfterDeserialization)]
+    private void AfterDeserializationHook() {
+      // BackwardsCompatibility3.3
+      #region Backwards compatible code (remove with 3.4)
+      if (operators == null) InitializeOperators();
+      #endregion
+      AttachEventHandlers();
+    }
+
     private void AttachEventHandlers() {
-      // Start BackwardsCompatibility3.3 (remove with 3.4)
-      if (operators == null) InitializeOperators();
-      // End BackwardsCompatibility3.3
       SolutionCreatorParameter.ValueChanged += new EventHandler(SolutionCreatorParameter_ValueChanged);
       SolutionCreator.BinaryVectorParameter.ActualNameChanged += new EventHandler(SolutionCreator_BinaryVectorParameter_ActualNameChanged);
Index: /trunk/sources/HeuristicLab.Problems.OneMax/3.3/OnemaxProblem.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.OneMax/3.3/OnemaxProblem.cs	(revision 4117)
+++ /trunk/sources/HeuristicLab.Problems.OneMax/3.3/OnemaxProblem.cs	(revision 4118)
@@ -109,5 +109,5 @@
 
     [StorableConstructor]
-    private OneMaxProblem(bool deserializing) : base() { }
+    private OneMaxProblem(bool deserializing) : base(deserializing) { }
     public OneMaxProblem()
       : base() {
@@ -198,8 +198,13 @@
     #region Helpers
     [StorableHook(HookType.AfterDeserialization)]
+    private void AfterDeserializationHook() {
+      // BackwardsCompatibility3.3
+      #region Backwards compatible code (remove with 3.4)
+      if (operators == null) InitializeOperators();
+      #endregion
+      AttachEventHandlers();
+    }
+
     private void AttachEventHandlers() {
-      // Start BackwardsCompatibility3.3 (remove with 3.4)
-      if (operators == null) InitializeOperators();
-      // End BackwardsCompatibility3.3
       SolutionCreatorParameter.ValueChanged += new EventHandler(SolutionCreatorParameter_ValueChanged);
       SolutionCreator.BinaryVectorParameter.ActualNameChanged += new EventHandler(SolutionCreator_BinaryVectorParameter_ActualNameChanged);
@@ -207,7 +212,7 @@
       LengthParameter.ValueChanged += new EventHandler(LengthParameter_ValueChanged);
       LengthParameter.Value.ValueChanged += new EventHandler(Length_ValueChanged);
-      BestKnownQualityParameter.Value.Value = Length.Value;
       BestKnownQualityParameter.ValueChanged += new EventHandler(BestKnownQualityParameter_ValueChanged);
     }
+
     private void ParameterizeSolutionCreator() {
       SolutionCreator.LengthParameter.ActualName = LengthParameter.Name;
Index: /trunk/sources/HeuristicLab.Problems.TestFunctions/3.3/SingleObjectiveTestFunctionProblem.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.TestFunctions/3.3/SingleObjectiveTestFunctionProblem.cs	(revision 4117)
+++ /trunk/sources/HeuristicLab.Problems.TestFunctions/3.3/SingleObjectiveTestFunctionProblem.cs	(revision 4118)
@@ -131,5 +131,5 @@
 
     [StorableConstructor]
-    private SingleObjectiveTestFunctionProblem(bool deserializing) : base() { }
+    private SingleObjectiveTestFunctionProblem(bool deserializing) : base(deserializing) { }
     public SingleObjectiveTestFunctionProblem()
       : base() {
@@ -297,8 +297,13 @@
     #region Helpers
     [StorableHook(HookType.AfterDeserialization)]
+    private void AfterDeserializationHook() {
+      // BackwardsCompatibility3.3
+      #region Backwards compatible code (remove with 3.4)
+      if (operators == null) InitializeOperators();
+      #endregion
+      AttachEventHandlers();
+    }
+
     private void AttachEventHandlers() {
-      // Start BackwardsCompatibility3.3 (remove with 3.4)
-      if (operators == null) InitializeOperators();
-      // End BackwardsCompatibility3.3
       ProblemSizeParameter.ValueChanged += new EventHandler(ProblemSizeParameter_ValueChanged);
       ProblemSize.ValueChanged += new EventHandler(ProblemSize_ValueChanged);
Index: /trunk/sources/HeuristicLab.Problems.TravelingSalesman/3.3/TravelingSalesmanProblem.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.TravelingSalesman/3.3/TravelingSalesmanProblem.cs	(revision 4117)
+++ /trunk/sources/HeuristicLab.Problems.TravelingSalesman/3.3/TravelingSalesmanProblem.cs	(revision 4118)
@@ -132,5 +132,5 @@
 
     [StorableConstructor]
-    private TravelingSalesmanProblem(bool deserializing) : base() { }
+    private TravelingSalesmanProblem(bool deserializing) : base(deserializing) { }
     public TravelingSalesmanProblem()
       : base() {
@@ -246,8 +246,13 @@
     #region Helpers
     [StorableHook(HookType.AfterDeserialization)]
+    private void AfterDeserializationHook() {
+      // BackwardsCompatibility3.3
+      #region Backwards compatible code (remove with 3.4)
+      if (operators == null) InitializeOperators();
+      #endregion
+      AttachEventHandlers();
+    }
+
     private void AttachEventHandlers() {
-      // Start BackwardsCompatibility3.3 (remove with 3.4)
-      if (operators == null) InitializeOperators();
-      // End BackwardsCompatibility3.3
       CoordinatesParameter.ValueChanged += new EventHandler(CoordinatesParameter_ValueChanged);
       Coordinates.ItemChanged += new EventHandler<EventArgs<int, int>>(Coordinates_ItemChanged);
Index: /trunk/sources/HeuristicLab.Problems.VehicleRouting/3.3/VehicleRoutingProblem.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.VehicleRouting/3.3/VehicleRoutingProblem.cs	(revision 4117)
+++ /trunk/sources/HeuristicLab.Problems.VehicleRouting/3.3/VehicleRoutingProblem.cs	(revision 4118)
@@ -182,5 +182,5 @@
 
     [StorableConstructor]
-    private VehicleRoutingProblem(bool deserializing) : base() { }
+    private VehicleRoutingProblem(bool deserializing) : base(deserializing) { }
     public VehicleRoutingProblem()
       : base() {
@@ -295,8 +295,13 @@
     #region Helpers
     [StorableHook(HookType.AfterDeserialization)]
+    private void AfterDeserializationHook() {
+      // BackwardsCompatibility3.3
+      #region Backwards compatible code (remove with 3.4)
+      if (operators == null) InitializeOperators();
+      #endregion
+      AttachEventHandlers();
+    }
+
     private void AttachEventHandlers() {
-      // Start BackwardsCompatibility3.3 (remove with 3.4)
-      if (operators == null) InitializeOperators();
-      // End BackwardsCompatibility3.3
       CoordinatesParameter.ValueChanged += new EventHandler(CoordinatesParameter_ValueChanged);
       Vehicles.ValueChanged += new EventHandler(VehiclesValue_ValueChanged);