Index: branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment.Views/3.3/HiveExperimentView.Designer.cs
===================================================================
--- branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment.Views/3.3/HiveExperimentView.Designer.cs	(revision 4116)
+++ branches/3.3-HiveMigration/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment.Views/3.3/HiveExperimentView.Designer.cs	(revision 4120)
@@ -53,4 +53,7 @@
       this.loadExperimentButton = new System.Windows.Forms.Button();
       this.hiveStatusTabPage = new System.Windows.Forms.TabPage();
+      this.jobListView = new HeuristicLab.Hive.Experiment.Views.JobItemListView();
+      this.logTabPage = new System.Windows.Forms.TabPage();
+      this.logView = new HeuristicLab.Core.Views.LogView();
       this.startButton = new System.Windows.Forms.Button();
       this.stopButton = new System.Windows.Forms.Button();
@@ -66,4 +69,6 @@
       this.tabControl.SuspendLayout();
       this.experimentTabPage.SuspendLayout();
+      this.hiveStatusTabPage.SuspendLayout();
+      this.logTabPage.SuspendLayout();
       this.SuspendLayout();
       // 
@@ -85,8 +90,9 @@
       this.tabControl.Controls.Add(this.experimentTabPage);
       this.tabControl.Controls.Add(this.hiveStatusTabPage);
-      this.tabControl.Location = new System.Drawing.Point(0, 135);
+      this.tabControl.Controls.Add(this.logTabPage);
+      this.tabControl.Location = new System.Drawing.Point(0, 99);
       this.tabControl.Name = "tabControl";
       this.tabControl.SelectedIndex = 0;
-      this.tabControl.Size = new System.Drawing.Size(735, 359);
+      this.tabControl.Size = new System.Drawing.Size(735, 395);
       this.tabControl.TabIndex = 4;
       // 
@@ -100,5 +106,5 @@
       this.experimentTabPage.Name = "experimentTabPage";
       this.experimentTabPage.Padding = new System.Windows.Forms.Padding(3);
-      this.experimentTabPage.Size = new System.Drawing.Size(727, 333);
+      this.experimentTabPage.Size = new System.Drawing.Size(727, 369);
       this.experimentTabPage.TabIndex = 1;
       this.experimentTabPage.Text = "Experiment";
@@ -149,11 +155,48 @@
       // hiveStatusTabPage
       // 
+      this.hiveStatusTabPage.Controls.Add(this.jobListView);
       this.hiveStatusTabPage.Location = new System.Drawing.Point(4, 22);
       this.hiveStatusTabPage.Name = "hiveStatusTabPage";
       this.hiveStatusTabPage.Padding = new System.Windows.Forms.Padding(3);
-      this.hiveStatusTabPage.Size = new System.Drawing.Size(727, 333);
+      this.hiveStatusTabPage.Size = new System.Drawing.Size(727, 369);
       this.hiveStatusTabPage.TabIndex = 2;
       this.hiveStatusTabPage.Text = "HiveStatus";
       this.hiveStatusTabPage.UseVisualStyleBackColor = true;
+      // 
+      // jobListView
+      // 
+      this.jobListView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+                  | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.jobListView.Caption = "JobList View";
+      this.jobListView.Content = null;
+      this.jobListView.Location = new System.Drawing.Point(3, 6);
+      this.jobListView.Name = "jobListView";
+      this.jobListView.ReadOnly = false;
+      this.jobListView.Size = new System.Drawing.Size(721, 360);
+      this.jobListView.TabIndex = 0;
+      // 
+      // logTabPage
+      // 
+      this.logTabPage.Controls.Add(this.logView);
+      this.logTabPage.Location = new System.Drawing.Point(4, 22);
+      this.logTabPage.Name = "logTabPage";
+      this.logTabPage.Size = new System.Drawing.Size(727, 369);
+      this.logTabPage.TabIndex = 3;
+      this.logTabPage.Text = "Log";
+      this.logTabPage.UseVisualStyleBackColor = true;
+      // 
+      // logView
+      // 
+      this.logView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+                  | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.logView.Caption = "Log View";
+      this.logView.Content = null;
+      this.logView.Location = new System.Drawing.Point(3, 4);
+      this.logView.Name = "logView";
+      this.logView.ReadOnly = false;
+      this.logView.Size = new System.Drawing.Size(721, 362);
+      this.logView.TabIndex = 0;
       // 
       // startButton
@@ -300,4 +343,6 @@
       this.tabControl.ResumeLayout(false);
       this.experimentTabPage.ResumeLayout(false);
+      this.hiveStatusTabPage.ResumeLayout(false);
+      this.logTabPage.ResumeLayout(false);
       this.ResumeLayout(false);
       this.PerformLayout();
@@ -323,4 +368,7 @@
     private System.Windows.Forms.Button loadExperimentButton;
     private Core.Views.NamedItemView experimentNamedItemView;
+    private System.Windows.Forms.TabPage logTabPage;
+    private Core.Views.LogView logView;
+    private JobItemListView jobListView;
 
   }